package ru.ulstu.indicator.model;

import jakarta.persistence.CollectionTable;
import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.Lob;
import jakarta.validation.constraints.Max;
import jakarta.validation.constraints.Min;
import jakarta.validation.constraints.NotBlank;
import ru.ulstu.model.BaseEntity;

import java.util.ArrayList;
import java.util.List;

@Entity
public class Indicator extends BaseEntity {

    @NotBlank
    private String name;

    @Min(0)
    @Max(30)
    private int max;

    @NotBlank
    @Lob
    private String proofDocuments;

    @ElementCollection(targetClass = Course.class)
    @CollectionTable
    @Enumerated(EnumType.STRING)
    private List<Course> courses = new ArrayList<>();

    public Indicator() {
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getMax() {
        return max;
    }

    public void setMax(int max) {
        this.max = max;
    }

    public String getProofDocuments() {
        return proofDocuments;
    }

    public void setProofDocuments(String proofDocuments) {
        this.proofDocuments = proofDocuments;
    }

    public List<Course> getCourses() {
        return courses;
    }

    public void setCourses(List<Course> courses) {
        this.courses = courses;
    }
}
